# This file was generated by liblab | https://liblab.com/

from .services.flights_live_prices import FlightsLivePricesService
from .services.flights_indicative_prices import FlightsIndicativePricesService
from .services.culture import CultureService
from .services.geo import GeoService
from .services.autosuggest import AutosuggestService
from .services.carriers import CarriersService
from .net.environment import Environment


class SkyscannerB2b:
    def __init__(
        self,
        api_key: str = None,
        api_key_header: str = "X-API-KEY",
        base_url: str = Environment.DEFAULT.value,
    ):
        """
        Initializes SkyscannerB2b the SDK class.
        """
        self.flights_live_prices = FlightsLivePricesService(base_url=base_url)
        self.flights_indicative_prices = FlightsIndicativePricesService(
            base_url=base_url
        )
        self.culture = CultureService(base_url=base_url)
        self.geo = GeoService(base_url=base_url)
        self.autosuggest = AutosuggestService(base_url=base_url)
        self.carriers = CarriersService(base_url=base_url)
        self.set_api_key(api_key, api_key_header)

    def set_base_url(self, base_url):
        """
        Sets the base URL for the entire SDK.
        """
        self.flights_live_prices.set_base_url(base_url)
        self.flights_indicative_prices.set_base_url(base_url)
        self.culture.set_base_url(base_url)
        self.geo.set_base_url(base_url)
        self.autosuggest.set_base_url(base_url)
        self.carriers.set_base_url(base_url)

        return self

    def set_api_key(self, api_key: str, api_key_header="X-API-KEY"):
        """
        Sets the api key and the api key header for the entire SDK.
        """
        self.flights_live_prices.set_api_key(api_key, api_key_header)
        self.flights_indicative_prices.set_api_key(api_key, api_key_header)
        self.culture.set_api_key(api_key, api_key_header)
        self.geo.set_api_key(api_key, api_key_header)
        self.autosuggest.set_api_key(api_key, api_key_header)
        self.carriers.set_api_key(api_key, api_key_header)

        return self


# c029837e0e474b76bc487506e8799df5e3335891efe4fb02bda7a1441840310c
