# This file was generated by liblab | https://liblab.com/

from .utils.validator import Validator
from .utils.base_service import BaseService
from ..net.transport.serializer import Serializer
from ..models.utils.cast_models import cast_models
from ..models.hierarchy_flights_nearest_request import HierarchyFlightsNearestRequest


class GeoService(BaseService):

    @cast_models
    def hierarchy_flights(self, locale: str, x_api_key: str = None):
        """/hierarchy/flights

        :param locale: locale
        :type locale: str
        :param x_api_key: x_api_key, defaults to None
        :type x_api_key: str, optional
        ...
        :raises RequestError: Raised when a request fails, with optional HTTP status code and details.
        ...
        """

        Validator(str).validate(locale)
        Validator(str).is_optional().validate(x_api_key)

        serialized_request = (
            Serializer(
                f"{self.base_url}/apiservices/v3/geo/hierarchy/flights/{{locale}}",
                self.get_default_headers(),
            )
            .add_header("x-api-key", x_api_key)
            .add_path("locale", locale)
            .serialize()
            .set_method("GET")
        )

        response = self.send_request(serialized_request)

        return response

    @cast_models
    def hierarchy_flights_nearest(
        self, request_body: HierarchyFlightsNearestRequest = None, x_api_key: str = None
    ):
        """/hierarchy/flights/nearest

        :param request_body: The request body., defaults to None
        :type request_body: HierarchyFlightsNearestRequest, optional
        :param x_api_key: x_api_key, defaults to None
        :type x_api_key: str, optional
        ...
        :raises RequestError: Raised when a request fails, with optional HTTP status code and details.
        ...
        """

        Validator(HierarchyFlightsNearestRequest).is_optional().validate(request_body)
        Validator(str).is_optional().validate(x_api_key)

        serialized_request = (
            Serializer(
                f"{self.base_url}/apiservices/v3/geo/hierarchy/flights/nearest",
                self.get_default_headers(),
            )
            .add_header("x-api-key", x_api_key)
            .serialize()
            .set_method("POST")
            .set_body(request_body)
        )

        response = self.send_request(serialized_request)

        return response
